package obpro.gamefw;

import java.util.ArrayList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import obpro.common.BReflection;
import obpro.gui.BCanvas;
import obpro.gui.BWindow;

/*
 * GUIAnimationApplicationEngine.java
 * Copyright(c) 2005 CreW Project. All rights reserved.
 */

/**
 * GUIQ[@t[[N 
 * sGW
 * 
 * @author macchan
 * @version 1.0
 */
public class GUIAnimationApplicationEngine {

	public static void main(String[] args) {
		if (args.length != 1) {
			System.out.println("Nɂ͈Kvł");
			return;
		}

		//AvP[V𐶐CGWN
		AbstractGUIAnimationApplication application = (AbstractGUIAnimationApplication) BReflection
				.createInstanceByName(args[0]);
		GUIAnimationApplicationEngine engine = new GUIAnimationApplicationEngine(
				application);
		engine.run();
	}

	//sAvP[V
	private AbstractGUIAnimationApplication application;

	//EChE
	private BWindow window;

	//Aj[VIuWFNg̏W
	private List elements = new ArrayList();

	//^C}[֘A
	private Timer timer = new Timer();

	private double stepInterval = 0.03d;

	private Object lockObject = "locker";

	/**
	 * RXgN^
	 */
	public GUIAnimationApplicationEngine(
			AbstractGUIAnimationApplication application) {
		this.application = application;
		application.setEngine(this);
	}

	//AvP[Vs
	private void run() {
		openWindow();
		application.prepareAnimationStart();//Aj[V̊Jn(IuWFNgȂǂ)
		restartTimer();
		doAnimation();
	}

	//EChEJ
	private void openWindow() {
		window = new BWindow();
		application.initializeWindow(window);
		window.show();
	}

	//Aj[V
	private void doAnimation() {
		//LoX擾
		BCanvas canvas = window.getCanvas();

		//Aj[V
		while (true) {
			{//PR}̏s
				//Q[ŜƂĂ1R}̏s
				application.processOneStepForApplication(canvas);

				//eIuWFNg1R}̏s
				for (int i = 0; i < elements.size(); i++) {
					AnimationElement element = (AnimationElement) elements
							.get(i);
					element.processOneStep(canvas);
				}
			}

			//}``
			canvas.clear();
			application.drawForApplication(canvas);
			for (int i = 0; i < elements.size(); i++) {
				AnimationElement element = (AnimationElement) elements.get(i);
				element.draw(canvas);
			}
			canvas.update();

			//
			try {
				synchronized (lockObject) {
					lockObject.wait();
				}
			} catch (Exception ex) {
				throw new RuntimeException(ex);
			}
		}
	}

	/**
	 * PXebv̎Ԃݒ肷
	 */
	public void setStepInterval(double stepInterval) {
		this.stepInterval = stepInterval;
	}

	/**
	 * LN^[ǉ
	 */
	public void addElement(AnimationElement element) {
		elements.add(element);
	}

	/**
	 * LN^[폜
	 */
	public void removeElement(AnimationElement element) {
		elements.remove(element);
	}

	/**
	 * SLN^[폜
	 */
	public void removeAllElements() {
		elements.clear();
	}

	/**
	 * SLN^[̃Xg擾 
	 */
	public List getAllElements() {
		return new ArrayList(elements);
	}

	/**
	 * ^C}[Jn
	 */
	private void restartTimer() {
		timer.scheduleAtFixedRate(new GUIAnimationTimerTask(), 0,
				(long) (stepInterval * 1000));
	}

	/**
	 * ^C}[1XebvƂɌĂԏ\NX
	 */
	class GUIAnimationTimerTask extends TimerTask {
		public void run() {
			synchronized (lockObject) {
				lockObject.notify();
			}
		}
	}

}