package obpro.turtle;
import java.awt.event.InputMethodEvent;
import java.awt.event.InputMethodListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;

import javax.swing.JTextArea;
import javax.swing.SwingUtilities;
import javax.swing.text.BadLocationException;

/*
 * ConsoleTextArea.java
 * Created on 2011/12/17
 * Copyright(c) 2011 Yoshiaki Matsuzawa, Shizuoka University. All rights reserved.
 */

/**
 * R\[G~[gTextAreaNX
 * 
 * @author macchan
 * @version $Id: Turtle.java,v 1.11 2007/12/21 11:13:42 macchan Exp $
 */
public class ConsoleTextArea extends JTextArea {

	String text;

	// ֘A
	public JTextAreaPrintStream out = new JTextAreaPrintStream(this);

	public JTextAreaInputStream in = new JTextAreaInputStream(this);

	/**
	 * RXgN^ System.out, System.err̂Ȃs܂
	 */
	public ConsoleTextArea() {
		// Applet͂߂
		// System.setOut(this.out);
		// System.setIn(this.in);
		this.initialize();
	}

	/**
	 * ܂
	 */
	private void initialize() {
		// L[ɂAJ[\̈ړj~
		this.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				switch (e.getKeyCode()) {
				case KeyEvent.VK_UP:
				case KeyEvent.VK_DOWN:
				case KeyEvent.VK_LEFT:
				case KeyEvent.VK_RIGHT:
				case KeyEvent.VK_HOME:
				case KeyEvent.VK_END:
				case KeyEvent.VK_PAGE_UP:
				case KeyEvent.VK_PAGE_DOWN:
					e.consume();
				}
			}
		});

		// }EXɂAJ[\̈ړj~@iconsume()Ȃj
		// this.addMouseListener(new MouseListener() {
		// public void mouseClicked(MouseEvent e) {
		// e.consume();
		// }
		// public void mouseEntered(MouseEvent e) {
		// e.consume();
		// }
		// public void mouseExited(MouseEvent e) {
		// e.consume();
		// }
		// public void mousePressed(MouseEvent e) {
		// e.consume();
		// }
		// public void mouseReleased(MouseEvent e) {
		// e.consume();
		// }
		// });
	}

	/**
	 * JTextAreaR\[ɂ邽߂ System.in G~[^
	 * 
	 * pĂPrintableInputStreamprintln@\𗘗pď݂܂
	 * Block̎dg݂PrintableInputStreamˑł
	 * 
	 * @author macchan
	 * @version $Id: Turtle.java,v 1.11 2007/12/21 11:13:42 macchan Exp $
	 */
	class JTextAreaInputStream extends PrintableInputStream {

		// 萔
		private static final int NULL = -1;

		// 
		private int inputStartCaretPosition = NULL; // ͂n܂J[\ʒuoĂ

		// ֘A
		private JTextArea textArea = null;

		/**
		 * Constructor for JTextAreaInputStream.
		 */
		public JTextAreaInputStream(JTextArea textArea) {
			this.textArea = textArea;
			this.initialize();
		}

		/**
		 * ܂
		 */
		private void initialize() {
			this.textArea.addKeyListener(new KeyAdapter() {
				public void keyPressed(KeyEvent e) {
					handleKeyPressed(e);
				}
			});
			this.textArea.addInputMethodListener(new InputMethodListener() {
				public void caretPositionChanged(InputMethodEvent event) {
					// donothing
				}

				public void inputMethodTextChanged(InputMethodEvent event) {
					memorizeStartPosition();
				}
			});
		}

		public synchronized void memorizeStartPosition() {
			// ŏ̓͂ȂAʒuoĂ
			if (this.inputStartCaretPosition == NULL) {
				this.inputStartCaretPosition = this.textArea.getCaretPosition();
			}
		}

		/**
		 * L[ꂽ̏
		 */
		public synchronized void handleKeyPressed(KeyEvent e) {
			this.memorizeStartPosition();

			// EnterȂAݓs
			if (e.getKeyCode() == KeyEvent.VK_ENTER) {
				e.consume();
				this.writeLine();
				this.inputStartCaretPosition = NULL;
				this.textArea.repaint();
			}
		}

		private void writeLine() {
			try {
				int inputEndCaretPosition = this.textArea.getCaretPosition();
				int len = inputEndCaretPosition - this.inputStartCaretPosition;
				String lineString = null;
				if (len <= 0) {
					lineString = "";
				} else {
					lineString = this.textArea.getText(
							this.inputStartCaretPosition, len);
				}

				// ݂܂
				super.println(lineString);
			} catch (BadLocationException ex) {
				ex.printStackTrace();
			}
		}

	}

	/**
	 * JTextAreaR\[ɂ邽߂ System.out G~[^
	 * 
	 * println\bhƁAprint\bhAflush\bĥ݃I[o[Ch܂
	 * ͕̑WPrintStream̋@\gASystem.outɃRlNg܂
	 * 
	 * @author macchan
	 * @version $Id: Turtle.java,v 1.11 2007/12/21 11:13:42 macchan Exp $
	 */
	class JTextAreaPrintStream extends PrintStream {

		// 萔
		private static final char CR = '\n';

		// 
		private StringBuffer buf = new StringBuffer();

		// tO
		private boolean invokeLater = false; // flushSwingXbhŏ邩ǂ

		private boolean caretUpdate = true; // flushɃJ[\ړ邩ǂ

		// ֘A
		private JTextArea textArea = null;

		/**
		 * RXgN^
		 */
		public JTextAreaPrintStream(JTextArea textarea) {
			super(System.out); // System.out͉RlNg
			this.textArea = textarea;
		}

		/***********************************
		 * print֘A@iI[o[Chj
		 ***********************************/

		public void print(Object o) {
			this.printImpl(o.toString());
		}

		public void print(String s) {
			this.printImpl(s);
		}

		public void print(int i) {
			this.printImpl(new Integer(i).toString());
		}

		public void print(long l) {
			this.printImpl(new Long(l).toString());
		}

		public void print(char c) {
			this.printImpl(new Character(c).toString());
		}

		public void print(char[] c) {
			this.printImpl(new String(c));
		}

		public void print(boolean b) {
			this.printImpl(new Boolean(b).toString());
		}

		public void print(float s) {
			this.printImpl(new Float(s).toString());
		}

		public void print(double d) {
			this.printImpl(new Double(d).toString());
		}

		/***********************************
		 * println֘A@iI[o[Chj
		 ***********************************/

		public void println() {
			this.printlnImpl("");
		}

		public void println(Object o) {
			this.printlnImpl(o.toString());
		}

		public void println(String s) {
			this.printlnImpl(s);
		}

		public void println(int i) {
			this.printlnImpl(new Integer(i).toString());
		}

		public void println(long l) {
			this.printlnImpl(new Long(l).toString());
		}

		public void println(char c) {
			this.printlnImpl(new Character(c).toString());
		}

		public void println(char[] c) {
			this.printlnImpl(new String(c));
		}

		public void println(boolean b) {
			this.printlnImpl(new Boolean(b).toString());
		}

		public void println(float s) {
			this.printlnImpl(new Float(s).toString());
		}

		public void println(double d) {
			this.printlnImpl(new Double(d).toString());
		}

		/***********************************
		 * flush֘A@iI[o[Chj
		 ***********************************/

		/**
		 * textareaStreamo͂܂B
		 */
		public synchronized void flush() {
			this.flushImpl();
		}

		/***********************************
		 * ֘A
		 ***********************************/

		/**
		 * print̎ł obt@ɂ,flush܂(flush)
		 */
		private void printImpl(String s) {
			this.buf.append(s);
			this.flush();
		}

		/**
		 * println̎ł
		 */
		private void printlnImpl(String s) {
			this.printImpl(s + CR);
		}

		/**
		 * flush̎ł
		 */
		private void flushImpl() {
			// O
			final String s = this.buf.toString();

			// {(writeTextŏ)
			if (this.invokeLater) { // SwingXbhŏ
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {
						writeText(s);
					}
				});
			} else { // ̃Xbhŏ(̂܂܎s)
				writeText(s);
			}

			// ㏈
			this.buf = new StringBuffer();

		}

		/***********************************
		 * eLXgGAɏ݊֘A
		 ***********************************/

		/**
		 * eLXgeLXgGAɏ݂܂
		 */
		private void writeText(String s) {

			if (this.textArea == null) {
				throw new NullPointerException("textarea is null");
			}

			// eLXgGAɏ
			int caret = this.textArea.getCaretPosition();
			int len = this.textArea.getDocument().getLength();
			int pos = caret < len ? caret : len;
			this.textArea.insert(s, pos);

			// J[\ړ
			if (this.caretUpdate) {
				this.textArea.setCaretPosition(pos + s.length());
				this.textArea.repaint();
			}
		}

		/***********************************
		 * Setter, Getter֘A
		 ***********************************/

		public void setInvokeLater(boolean invokeLater) {
			this.invokeLater = invokeLater;
		}

		public boolean isInvokeLater() {
			return this.invokeLater;
		}

		public void setCaretUpdate(boolean caretUpdate) {
			this.caretUpdate = caretUpdate;
		}

		public boolean isCaretUpdate() {
			return this.caretUpdate;
		}

	}

	/**
	 * String߂InputStreamG~[^
	 * 
	 * write(String)\bhňsނƂł܂B
	 * ̃NX𗘗pǂݎ́Aread()Ƃbufferɏ܂ĂȂ΁A ܂܂ŃubN܂
	 * 
	 * @author macchan
	 * @version $Id: Turtle.java,v 1.11 2007/12/21 11:13:42 macchan Exp $
	 */
	class PrintableInputStream extends InputStream {

		// 萔
		private static final char CR = '\n';

		private static final char END_SYMBOL = '\0';

		private static final int END_CODE = -1;

		// 
		private byte[] buf = null; // byteŕ\obt@

		private int cursor = 0; // byteǂ܂œǂ񂾂ۑJ[\

		/**
		 * RXgN^
		 */
		public PrintableInputStream() {
		}

		/**
		 * obt@ɏ݂܂B ubÑXbhAubN܂
		 */
		public synchronized void println(String s) {
			// sƏIL
			s = s + CR + END_SYMBOL;

			// Ώەbytẽobt@ɕϊ
			byte[] stringBuf = s.getBytes();

			// obt@IɒBĂÂ܂܃obt@ɁB
			if (this.isBufferEnd()) {
				this.buf = stringBuf;
			}
			// obt@IɒBĂȂApāAVobt@
			else {
				int remain = buf.length - cursor; // Ⴆ8,4̏ꍇA0,1,2,34IĂ邩AcSB
				int newbufsize = remain + stringBuf.length;
				byte[] newBuf = new byte[newbufsize];
				System.arraycopy(buf, cursor, newBuf, 0, remain);
				System.arraycopy(stringBuf, 0, newBuf, remain, stringBuf.length);
				// Ⴆ13,4̏ꍇA13-4=9Rs[Ă̎9ԖځB
				buf = newBuf;
			}

			// J[\߂āAubN
			cursor = 0;
			notify();
		}

		/***************************************
		 * I[o[Ch
		 ***************************************/

		/**
		 * ubNɓǂݍ߂oCgԂ܂
		 */
		public synchronized int available() throws IOException {
			return buf == null ? 0 : buf.length - cursor;
		}

		/**
		 * obt@Aꕶǂݍ݂܂
		 */
		public synchronized int read() throws IOException {
			int readChar = END_CODE;

			try {
				// ǂݍ߂Ȃ΃ubN
				if (isBufferEnd()) {
					wait();
				}

				// ꕶǂݍ
				readChar = this.buf[cursor];
				this.cursor++;

				// I肾-1
				if ((char) readChar == END_SYMBOL) {
					return END_CODE;
				}

			} catch (InterruptedException ex) {
				ex.printStackTrace();
			}

			return readChar;
		}

		/***************************************
		 * private
		 ***************************************/

		/**
		 * obt@IĂ邩ǂׂ܂
		 */
		private synchronized boolean isBufferEnd() {
			return this.buf == null ? true : this.cursor >= this.buf.length;
		}
	}

}
